       IDENTIFICATION DIVISION.
       PROGRAM-ID.    CBLPRTC1.
       AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1987-2016 SimoTime Technologies.                *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only and does not imply publication   *
      * or disclosure.                                                *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any non-commercial purpose and without fee is hereby      *
      * granted, provided the SimoTime copyright notice appear on all *
      * copies of the software. The SimoTime name or Logo may not be  *
      * used in any advertising or publicity pertaining to the use    *
      * of the software without the written permission of SimoTime    *
      * Technologies.                                                 *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any commercial purpose requires a fee to be paid to       *
      * SimoTime Technologies. Once the fee is received by SimoTime   *
      * the latest version of the software will be delivered and a    *
      * license will be granted for use within an enterprise,         *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * SimoTime Technologies makes no warranty or representations    *
      * about the suitability of the software for any purpose. It is  *
      * provided "AS IS" without any expressed or implied warranty,   *
      * including the implied warranties of merchantability, fitness  *
      * for a particular purpose and non-infringement. SimoTime       *
      * Technologies shall not be liable for any direct, indirect,    *
      * special or consequential damages resulting from the loss of   *
      * use, data or projects, whether in an action of contract or    *
      * tort, arising out of or in connection with the use or         *
      * performance of this software                                  *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *                                                               *
      *****************************************************************
      *      This program is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *                                                               *
      *****************************************************************
      *
      *****************************************************************
      * Source Member: CBLPRTC1.CBL
      * Copy Files:    BIN256B1.CPY
      *                PRTASCB1.CPY
      *                PRTASCB2.CPY
      *                PRTEBCB1.CPY
      *                PRTEBCB2.CPY
      *****************************************************************
      *
      * CBLPRTC1 - Show what happens when binary data is in a display
      *            message.
      *
      * CALLING PROTOCOL
      * ----------------
      * Use standard procedure to RUN or ANIMATE.
      *
      * DESCRIPTION
      * -----------
      * This program will create a text string with non-display binary
      * data and then attempt to display (refer to TEST-01-ROUTINE).
      * The same test is performed (refer to TEST-02-ROUTINE) with but
      * the message display routine will scan the display buffer to
      * remove any non-display values from the text string.
      *
      *          ************
      *          * CBLPRTJ1 *
      *          ********jcl*
      *               *
      *               *
      *          ************     ************
      *          * CBLPRTC1 *-----* CONSOLE  *
      *          ********cbl*  *  ******dsply*
      *               *        *
      *               *        *
      *               *        *  ************
      *               *        *--* SYSMEMO1 *
      *               *           ********txt*
      *          ************
      *          *   EOJ    *
      *          ************
      *
      *****************************************************************
      *
      * MAINTENANCE
      * -----------
      * 1989/02/27 Simmons, Created program.
      * 1997/03/17 Simmons, No changes to date....
      *
      *****************************************************************
      *
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT SYSMEMO1-FILE  ASSIGN to     SYSMEMO1
                  ORGANIZATION is SEQUENTIAL
                  ACCESS MODE  is SEQUENTIAL
                  FILE STATUS  is SYSMEMO1-STATUS.

      *****************************************************************
       DATA DIVISION.
       FILE SECTION.
       FD  SYSMEMO1-FILE
           DATA RECORD    is SYSMEMO1-RECORD
           .
       01  SYSMEMO1-RECORD.
           05  SYSMEMO1-DATA-01  pic X(00080).

       WORKING-STORAGE SECTION.
      *****************************************************************
      *    Data-structure for Title and Copyright...
      *    ------------------------------------------------------------
       01  SIM-TITLE.
           05  T1 pic X(11) value '* CBLPRTC1 '.
           05  T2 pic X(34) value 'Sample Print with Embedded Hex... '.
           05  T3 pic X(10) value ' v05.11.09'.
           05  T4 pic X(24) value ' http://www.simotime.com'.
       01  SIM-COPYRIGHT.
           05  C1 pic X(11) value '* CBLPRTC1 '.
           05  C2 pic X(20) value 'Copyright 1987-2016 '.
           05  C3 pic X(28) value '   SimoTime Technologies    '.
           05  C4 pic X(20) value ' All Rights Reserved'.

       01  SIM-THANKS-01.
           05  C1 pic X(11) value '* CBLPRTC1 '.
           05  C2 pic X(32) value 'Thank you for using this program'.
           05  C3 pic X(32) value ' provided from SimoTime Technolo'.
           05  C4 pic X(04) value 'gies'.

       01  SIM-THANKS-02.
           05  C1 pic X(11) value '* CBLPRTC1 '.
           05  C2 pic X(32) value 'Please send all inquires or sugg'.
           05  C3 pic X(32) value 'estions to the helpdesk@simotime'.
           05  C4 pic X(04) value '.com'.

      *****************************************************************
      *    Buffer used for posting messages to the console.
      *    ------------------------------------------------------------
       01  MESSAGE-BUFFER.
           05  MESSAGE-HEADER      pic X(11)   value '* CBLPRTC1 '.
           05  MESSAGE-TEXT.
               10  MESSAGE-TEXT-1  pic X(68)   value SPACES.
               10  MESSAGE-TEXT-2  pic X(188)  value SPACES.

       01  SYSMEMO1-STATUS.
           05  SYSMEMO1-STATUS-L   pic X.
           05  SYSMEMO1-STATUS-R   pic X.
       01  SYSMEMO1-EOF            pic X       value 'N'.
       01  SYSMEMO1-OPEN-FLAG      pic X       value 'C'.

       01  IO-STATUS.
           05  IO-STAT1            pic X.
           05  IO-STAT2            pic X.
       01  TWO-BYTES.
           05  TWO-BYTES-LEFT      pic X.
           05  TWO-BYTES-RIGHT     pic X.
       01  TWO-BYTES-BINARY        redefines TWO-BYTES pic 9(4) comp.

       01  APPL-RESULT             pic S9(9)   comp.
           88  APPL-AOK            value 0.
           88  APPL-EOF            value 16.

      *****************************************************************
      *    Work fields used for testing Print or Display.
      *    ------------------------------------------------------------
       01  TEST-BUFFER.
           05  FILLER      pic X(5)  value 'Test-'.
           05  TEST-CTR    pic 9(3)  value 0.
           05  FILLER      pic X     value ','.
           05  TEST-HEX    pic X     value SPACE.
           05  FILLER      pic X     value ','.
           05  FILLER      pic X(21) value 'End-of-Text-String...'.

       01  A-ASCII         pic X     value x'41'.
       01  A-EBCDIC        pic X     value x'C1'.
       01  A-COMPILE       pic X     value 'A'.

       01  IX-1            pic 9(3)  value 0.
       01  IX-2            pic 9(3)  value 0.

       01  DISPLAY-LINE.
           05  DISPLAY-VALUE   pic X(16)    value SPACES.
           05  DISPLAY-TEXT    pic X(20)    value SPACES.
       01  MESSAGE-ITEMS.
           05  FILLER pic X(20)    value ' * hex-00 to hex-0F '.
           05  FILLER pic X(20)    value ' * hex-10 to hex-1F '.
           05  FILLER pic X(20)    value ' * hex-20 to hex-2F '.
           05  FILLER pic X(20)    value ' * hex-30 to hex-3F '.
           05  FILLER pic X(20)    value ' * hex-40 to hex-4F '.
           05  FILLER pic X(20)    value ' * hex-50 to hex-5F '.
           05  FILLER pic X(20)    value ' * hex-60 to hex-6F '.
           05  FILLER pic X(20)    value ' * hex-70 to hex-7F '.
           05  FILLER pic X(20)    value ' * hex-80 to hex-8F '.
           05  FILLER pic X(20)    value ' * hex-90 to hex-9F '.
           05  FILLER pic X(20)    value ' * hex-A0 to hex-AF '.
           05  FILLER pic X(20)    value ' * hex-B0 to hex-BF '.
           05  FILLER pic X(20)    value ' * hex-C0 to hex-CF '.
           05  FILLER pic X(20)    value ' * hex-D0 to hex-DF '.
           05  FILLER pic X(20)    value ' * hex-E0 to hex-EF '.
           05  FILLER pic X(20)    value ' * hex-F0 to hex-FF '.
       01  MESSAGE-TABLE           redefines MESSAGE-ITEMS.
           05  MESSAGE-ELEMENT     pic X(20)   occurs 16 times.

       COPY BIN256B1.

       COPY PRTASCB1.
       COPY PRTEBCB1.
       COPY PRTASCB2.
       COPY PRTEBCB2.

      *****************************************************************
       PROCEDURE DIVISION.

           perform Z-POST-COPYRIGHT

           perform SYSMEMO1-OPEN

           perform TEST-01-ROUTINE

           perform TEST-02-ROUTINE

           perform TEST-03-ROUTINE

           perform TEST-04-ROUTINE

           perform TEST-05-ROUTINE

           perform TEST-06-ROUTINE

           perform TEST-07-ROUTINE

           perform SYSMEMO1-CLOSE

           perform Z-THANK-YOU.

           GOBACK.

      *****************************************************************
       PUT-APPL-MESSAGE.
           move MESSAGE-TEXT to SYSMEMO1-DATA-01
           perform Z-DISPLAY-CONSOLE-MESSAGE
           perform SYSMEMO1-WRITE
           exit.

      *****************************************************************
       PUT-APPL-MESSAGE-WITH-EDIT.
      *    The following inspect will replace any non-display text
      *    bytes with a space. The following evaluate will determine
      *    if the program has been compiled for an ASCII or EBCDIC
      *    environment and then replace the appropriate non-display
      *    characters with the appropriate space character.
           evaluate A-COMPILE
             when A-ASCII  inspect MESSAGE-TEXT
                           converting B-INFO to P1-ASC
             when A-EBCDIC inspect MESSAGE-TEXT
                           converting B-INFO to P1-EBC
           end-evaluate
           move MESSAGE-TEXT to SYSMEMO1-DATA-01
           perform Z-DISPLAY-CONSOLE-MESSAGE
           perform SYSMEMO1-WRITE
           exit.

      *****************************************************************
       PUT-APPL-MESSAGE-WITH-EDIT-2.
      *    The following inspect will replace any non-display text
      *    bytes with a space. The following evaluate will determine
      *    if the program has been compiled for an ASCII or EBCDIC
      *    environment and then replace the appropriate non-display
      *    characters with the appropriate space character.
           evaluate A-COMPILE
             when A-ASCII  inspect MESSAGE-TEXT
                           converting B-INFO to P2-ASC
             when A-EBCDIC inspect MESSAGE-TEXT
                           converting B-INFO to P2-EBC
           end-evaluate
           move MESSAGE-TEXT to SYSMEMO1-DATA-01
           perform Z-DISPLAY-CONSOLE-MESSAGE
           perform SYSMEMO1-WRITE
           exit.

      *****************************************************************
       TEST-01-ROUTINE.
           move 'TEST-01-ROUTINE is Starting...' to MESSAGE-TEXT
           perform PUT-APPL-MESSAGE-WITH-EDIT

           move ZERO  to TEST-CTR
           move SPACE to TEST-HEX

           move TEST-BUFFER to MESSAGE-TEXT
           perform PUT-APPL-MESSAGE-WITH-EDIT

           perform varying TEST-CTR from 0 by 1
           until TEST-CTR > 16
      *      Force a binary value into the text string to be displayed.
      *      As TEST-CTR is incremented a non-display value of x'00'
      *      through x'0F' is placed in the message to be displayed.
             move B-INFO(TEST-CTR + 1:1) to TEST-HEX
             move TEST-BUFFER to MESSAGE-TEXT
      *      The following perform will attempt to display the text
      *      string without testing and changing the embedded
      *      non-display, non-print characters.
             perform PUT-APPL-MESSAGE
           end-perform

           move 'TEST-01-ROUTINE is Finished...' to MESSAGE-TEXT
           perform PUT-APPL-MESSAGE-WITH-EDIT

           exit.

      *****************************************************************
       TEST-02-ROUTINE.
           move 'TEST-02-ROUTINE is Starting...' to MESSAGE-TEXT
           perform PUT-APPL-MESSAGE-WITH-EDIT

           move ZERO to TEST-CTR
           move SPACE to TEST-HEX

           move TEST-BUFFER to MESSAGE-TEXT
           perform PUT-APPL-MESSAGE-WITH-EDIT

           perform varying TEST-CTR from 0 by 1
           until TEST-CTR > 16
      *      Force a binary value into the text string to be displayed
             move B-INFO(TEST-CTR + 1:1) to TEST-HEX
             move TEST-BUFFER to MESSAGE-TEXT
      *      The following perform will attempt to display the text
      *      string after testing and changing the embedded
      *      non-display, non-print characters to a space character.
             perform PUT-APPL-MESSAGE-WITH-EDIT
           end-perform

           move 'TEST-02-ROUTINE is Finished...' to MESSAGE-TEXT
           perform PUT-APPL-MESSAGE-WITH-EDIT

           exit.

      *****************************************************************
       TEST-03-ROUTINE.
           move 'TEST-03-ROUTINE is Starting...' to MESSAGE-TEXT
           perform PUT-APPL-MESSAGE-WITH-EDIT

           move 'Next two lines should be identical...' to MESSAGE-TEXT
           perform PUT-APPL-MESSAGE-WITH-EDIT

           move 'Test-0D0A '  to MESSAGE-TEXT(1:10)
           move x'0D0A'       to MESSAGE-TEXT(11:2)
           move 'End-of-Text-String' to MESSAGE-TEXT(13:18)
      *      The following perform will attempt to display the text
      *      string without testing and changing the embedded
      *      carriage-return, line feed characters.
           perform PUT-APPL-MESSAGE

           move 'Test-0D0A '  to MESSAGE-TEXT(1:10)
           move x'0D0A'       to MESSAGE-TEXT(11:2)
           move 'End-of-Text-String' to MESSAGE-TEXT(13:18)
           perform PUT-APPL-MESSAGE-WITH-EDIT

           move 'TEST-03-ROUTINE is Finished...' to MESSAGE-TEXT
           perform PUT-APPL-MESSAGE-WITH-EDIT

           exit.

      *****************************************************************
       TEST-04-ROUTINE.
           move 'TEST-04-ROUTINE is Starting...' to MESSAGE-TEXT
           perform PUT-APPL-MESSAGE
           perform varying IX-1 from 1 by 16 until IX-1 > 256
             move B-INFO(IX-1:16) to MESSAGE-TEXT(13:18)
      *      The following perform will attempt to display the text
      *      string without testing and changing the embedded
      *      carriage-return, line feed characters.
             perform PUT-APPL-MESSAGE
           end-perform
           move 'TEST-04-ROUTINE is Finished...' to MESSAGE-TEXT
           perform PUT-APPL-MESSAGE-WITH-EDIT
           exit.

      *****************************************************************
       TEST-05-ROUTINE.
           move 'TEST-05-ROUTINE is Starting...' to MESSAGE-TEXT
           perform PUT-APPL-MESSAGE
           add 3 to ZERO giving IX-2
           perform varying IX-1 from 33 by 16 until IX-1 > 256
             move B-INFO(IX-1:16) to DISPLAY-VALUE
             move MESSAGE-ELEMENT(IX-2)to DISPLAY-TEXT
             move DISPLAY-LINE to MESSAGE-TEXT
      *      The following perform will attempt to display the text
      *      string without testing and changing the embedded
      *      carriage-return, line feed characters.
             perform PUT-APPL-MESSAGE
             add 1 to IX-2
           end-perform
           move 'TEST-05-ROUTINE is Finished...' to MESSAGE-TEXT
           perform PUT-APPL-MESSAGE-WITH-EDIT
           exit.

      *****************************************************************
       TEST-06-ROUTINE.
           move 'TEST-06-ROUTINE is Starting...' to MESSAGE-TEXT
           perform PUT-APPL-MESSAGE
           add 1 to ZERO giving IX-2
           perform varying IX-1 from 1 by 16 until IX-1 > 256
             move B-INFO(IX-1:16) to DISPLAY-VALUE
             move MESSAGE-ELEMENT(IX-2)to DISPLAY-TEXT
             move DISPLAY-LINE to MESSAGE-TEXT
      *      The following perform will attempt to display the text
      *      string with testing and changing the embedded non-display
      *      characters using the USA table.
             perform PUT-APPL-MESSAGE-WITH-EDIT
             add 1 to IX-2
           end-perform
           move 'TEST-06-ROUTINE is Finished...' to MESSAGE-TEXT
           perform PUT-APPL-MESSAGE-WITH-EDIT
           exit.

      *****************************************************************
       TEST-07-ROUTINE.
           move 'TEST-07-ROUTINE is Starting...' to MESSAGE-TEXT
           perform PUT-APPL-MESSAGE
           add 1 to ZERO giving IX-2
           perform varying IX-1 from 1 by 16 until IX-1 > 256
             move B-INFO(IX-1:16) to DISPLAY-VALUE
             move MESSAGE-ELEMENT(IX-2)to DISPLAY-TEXT
             move DISPLAY-LINE to MESSAGE-TEXT
      *      The following perform will attempt to display the text
      *      string with testing and changing the embedded non-display
      *      characters using the extended table.
             perform PUT-APPL-MESSAGE-WITH-EDIT-2
             add 1 to IX-2
           end-perform
           move 'TEST-07-ROUTINE is Finished...' to MESSAGE-TEXT
           perform PUT-APPL-MESSAGE
           exit.

      *****************************************************************
      * I/O ROUTINES FOR SYSMEMO1...                                  *
      *****************************************************************
       SYSMEMO1-WRITE.
           if  SYSMEMO1-OPEN-FLAG = 'C'
               perform SYSMEMO1-OPEN
           end-if
           write SYSMEMO1-RECORD
           if  SYSMEMO1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  SYSMEMO1-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if.
           if  APPL-AOK
               CONTINUE
           else
               move 'SYSMEMO1-Failure-WRITE...' to MESSAGE-TEXT
               perform Z-DISPLAY-CONSOLE-MESSAGE
               move SYSMEMO1-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       SYSMEMO1-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open output SYSMEMO1-FILE
           if  SYSMEMO1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to SYSMEMO1-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'SYSMEMO1-Failure-OPEN...' to MESSAGE-TEXT
               perform Z-DISPLAY-CONSOLE-MESSAGE
               move SYSMEMO1-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       SYSMEMO1-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close SYSMEMO1-FILE
           if  SYSMEMO1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'C' to SYSMEMO1-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'SYSMEMO1-Failure-CLOSE...' to MESSAGE-TEXT
               perform Z-DISPLAY-CONSOLE-MESSAGE
               move SYSMEMO1-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * The following Z-Routines perform administrative tasks         *
      * for this program.                                             *
      *****************************************************************
      * ABEND the program, post a message to the console and issue    *
      * a STOP RUN.                                                   *
      *****************************************************************
       Z-ABEND-PROGRAM.
           if  MESSAGE-TEXT not = SPACES
               perform Z-DISPLAY-CONSOLE-MESSAGE
           end-if
           move 'PROGRAM-IS-ABENDING...'  to MESSAGE-TEXT
           perform Z-DISPLAY-CONSOLE-MESSAGE
           add 12 to ZERO giving RETURN-CODE
           STOP RUN.
      *    exit.

      *****************************************************************
       Z-POST-COPYRIGHT.
           display SIM-TITLE
           display SIM-COPYRIGHT
           exit.

      *****************************************************************
      * Display the file status bytes. This routine will display as   *
      * two digits if the full two byte file status is numeric. If    *
      * second byte is non-numeric then it will be treated as a       *
      * binary number.                                                *
      *****************************************************************
       Z-DISPLAY-IO-STATUS.
           if  IO-STATUS not NUMERIC
           or  IO-STAT1    = '9'
               subtract TWO-BYTES-BINARY from TWO-BYTES-BINARY
               move IO-STAT2 to TWO-BYTES-RIGHT
               display '* CBLPRTC1 File-Status-' IO-STAT1 '/'
                       TWO-BYTES-BINARY upon console
               display '* CBLPRTC1 File-Status-' IO-STAT1 '/'
                       TWO-BYTES-BINARY
           else
               display '* CBLPRTC1 File-Status-' IO-STATUS upon console
               display '* CBLPRTC1 File-Status-' IO-STATUS
           end-if
           exit.

      *****************************************************************
      * Display CONSOLE messages...                                   *
      *****************************************************************
       Z-DISPLAY-CONSOLE-MESSAGE.
           if MESSAGE-TEXT-2 = SPACES
               display MESSAGE-BUFFER(1:79)
           else
               display MESSAGE-BUFFER
           end-if
           move all SPACES to MESSAGE-TEXT
           exit.

      *****************************************************************
       Z-THANK-YOU.
           display SIM-THANKS-01
           display SIM-THANKS-02
           exit.
      *****************************************************************
      *      This example is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
