@echo OFF
rem  * *******************************************************************
rem  *               CBLPRTE1.cmd - a Windows Command File               *
rem  *         This program is provided by SimoTime Technologies         *
rem  *           (C) Copyright 1987-2016 All Rights Reserved             *
rem  *             Web Site URL:   http://www.simotime.com               *
rem  *                   e-mail:   helpdesk@simotime.com                 *
rem  * *******************************************************************
rem  *
rem  * Text   - Create a Record Sequential File of 80-byte records.
rem  * Author - SimoTime Technologies
rem  * Date   - January 24, 1996
rem  *
rem  * The first job step (DeleteQSAM) will delete any previously created
rem  * file.
rem  *
rem  * The second job step (CreateQSAM) will create a new file of 80-byte
rem  * records.
rem  * For this program to work the COBOL program must be compiled with
rem  * the ASSIGN(EXTERNAL) and SEQUENTIAL(LINE) directives under
rem  * Net Express.
rem  *
rem  * This set of programs will run on a Linux. UNIX or Windows system
rem  * with Micro Focus technology.
rem  *
rem  * ********************************************************************
rem  * Step   1 of 2  Set the global environment variables,
rem  *                Delete any previously created file...
rem  *
     set CmdName=CBLPRTE1
     call ..\ENV1BASE
rem  *
     call SimoNOTE "*******************************************************%CmdName%"
     call SimoNOTE "Starting JobName %CmdName%, User is %USERNAME%"
     call SimoNOTE "Identify JobStep DeleteQSAM"
:DeleteQSAM
     set SYSMEMO1=%BaseLib1%\DATA\WRK1\SYSMEMO1.DAT
     if exist %SYSMEMO1% erase %SYSMEMO1%
rem  *
rem  * *******************************************************************
rem  * Step   2 of 2  Create and populate a new QSAM file...
rem  *
:CreateQSAM
     call SimoNOTE "Identify JobStep CreateQSAM"
     run CBLPRTC1
     echo ERRORLEVEL is %ERRORLEVEL%
     if not "%ERRORLEVEL%" == "0" set JobStatus=0010
     if not "%JobStatus%" == "0000" goto :EojNOK
rem  *
     if exist %SYSMEMO1% goto :EojAok
     set JobStatus=0020
     goto :EojNok
:EojAok
     call SimoNOTE "DATAMAKE %SYSMEMO1%"
     call SimoNOTE "SYSOUT.. %SYSOUT%"
     call SimoNOTE "Finished JobName %CmdName%, Job Status is %JobStatus%"
     goto :End
:EojNok
     call SimoNOTE "ABENDING JobName %CmdName%, Job Status is %JobStatus%"
:End
     call SimoNOTE "Conclude SysLog is %SYSLOG%"
     if not "%1" == "nopause" pause
